package com.logicbig.example;

import javax.persistence.*;
import java.util.Collections;

public class ExampleMain2 {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            System.out.println("-- persisting entity --");
            persistEntity();
            System.out.println("-- loading entity --");
            loadEntity();
        } finally {
            entityManagerFactory.close();
        }
    }

    public static void persistEntity() {
        Employee employee = new Employee();
        employee.setName("Dawn");
        employee.setDept("IT");
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        System.out.println("Employee persisted: " + employee);
        em.close();
        printCacheState();
    }

    private static void loadEntity() {
        EntityManager em = entityManagerFactory.createEntityManager();
        Employee employee = em.find(Employee.class, 1L,
                Collections.singletonMap("javax.persistence.cache.storeMode", CacheStoreMode.REFRESH));
        System.out.println("Employee loaded: " + employee);
        em.close();
        printCacheState();
    }

    private static void printCacheState() {
        Cache cache = entityManagerFactory.getCache();
        boolean contains = cache.contains(Employee.class, 1L);
        System.out.printf("Cache#contains() for Employee: %5s%n", contains);
    }
}